diff -Naur test-for-latech/Makefile testqf-for-latech/Makefile
--- test-for-latech/Makefile	2004-06-11 07:39:56.000000000 -0400
+++ testqf-for-latech/Makefile	2004-06-11 07:47:19.000000000 -0400
@@ -1,7 +1,7 @@
 VERSION = 2
 PATCHLEVEL = 4
 SUBLEVEL = 19
-EXTRAVERSION =
+EXTRAVERSION = -qfabric
 
 KERNELRELEASE=$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)
 
diff -Naur test-for-latech/mm/filemap.c testqf-for-latech/mm/filemap.c
--- test-for-latech/mm/filemap.c	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/mm/filemap.c	2004-06-11 07:47:23.000000000 -0400
@@ -2883,6 +2883,14 @@
 	return page;
 }
 
+#ifdef CONFIG_QFABRIC
+struct page *grab_cache_page_ex(struct address_space *mapping, 
+				unsigned long index, struct page **cached_page)
+{
+	return __grab_cache_page(mapping, index, cached_page);
+}
+#endif
+
 inline void remove_suid(struct inode *inode)
 {
 	unsigned int mode;
diff -Naur test-for-latech/mm/mlock.c testqf-for-latech/mm/mlock.c
--- test-for-latech/mm/mlock.c	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/mm/mlock.c	2004-06-11 07:47:23.000000000 -0400
@@ -12,6 +12,10 @@
 #include <asm/uaccess.h>
 #include <asm/pgtable.h>
 
+#ifdef CONFIG_QFABRIC
+extern int security_off;
+#endif
+
 static inline int mlock_fixup_all(struct vm_area_struct * vma, int newflags)
 {
 	spin_lock(&vma->vm_mm->page_table_lock);
@@ -151,8 +155,14 @@
 	struct vm_area_struct * vma, * next;
 	int error;
 
+#ifdef CONFIG_QFABRIC
+	if (security_off != 1)
+		if (on && !capable(CAP_IPC_LOCK))
+			return -EPERM;
+#else
 	if (on && !capable(CAP_IPC_LOCK))
 		return -EPERM;
+#endif
 	len = PAGE_ALIGN(len);
 	end = start + len;
 	if (end < start)
diff -Naur test-for-latech/net/Config.in testqf-for-latech/net/Config.in
--- test-for-latech/net/Config.in	2004-06-11 07:40:47.000000000 -0400
+++ testqf-for-latech/net/Config.in	2004-06-11 07:47:57.000000000 -0400
@@ -94,6 +94,12 @@
 #bool 'Network code profiler' CONFIG_NET_PROFILE
 endmenu
 
+#mainmenu_option next_comment
+#comment 'QSockets'
+if [ "$CONFIG_NET_CLS_SOCKET" = "y" ]; then
+  bool ' QSocket support' CONFIG_NET_QSOCKET
+fi
+
 mainmenu_option next_comment
 comment 'Network testing'
 tristate 'Packet Generator (USE WITH CAUTION)' CONFIG_NET_PKTGEN
diff -Naur test-for-latech/net/core/dev.c testqf-for-latech/net/core/dev.c
--- test-for-latech/net/core/dev.c	2004-06-11 07:40:49.000000000 -0400
+++ testqf-for-latech/net/core/dev.c	2004-06-11 07:47:57.000000000 -0400
@@ -1,4 +1,4 @@
-/*
+ /*
  * 	NET3	Protocol independent device support routines.
  *
  *		This program is free software; you can redistribute it and/or
@@ -977,6 +977,7 @@
 {
 	struct net_device *dev = skb->dev;
 	struct Qdisc  *q;
+	int rt_data = 0;
 
 	if (skb_shinfo(skb)->frag_list &&
 	    !(dev->features&NETIF_F_FRAGLIST) &&
@@ -1009,14 +1010,16 @@
 
 	/* Grab device queue */
 	spin_lock_bh(&dev->queue_lock);
-	q = dev->qdisc;
-	if (q->enqueue) {
-		int ret = q->enqueue(skb, q);
+	if (rt_data != 1) {
+		q = dev->qdisc;
+		if (q->enqueue) {
+			int ret = q->enqueue(skb, q);
 
-		qdisc_run(dev);
+			qdisc_run(dev);
 
-		spin_unlock_bh(&dev->queue_lock);
-		return ret == NET_XMIT_BYPASS ? NET_XMIT_SUCCESS : ret;
+			spin_unlock_bh(&dev->queue_lock);
+			return ret == NET_XMIT_BYPASS ? NET_XMIT_SUCCESS : ret;
+		}
 	}
 
 	/* The device has no queue. Common case for software devices:
@@ -1621,7 +1624,7 @@
  *	Thus we will need a 'compatibility mode'.
  */
 
-static int dev_ifconf(char *arg)
+static int dev_ifconf2(char *arg, int flag)
 {
 	struct ifconf ifc;
 	struct net_device *dev;
@@ -1633,9 +1636,12 @@
 	/*
 	 *	Fetch the caller's info block. 
 	 */
-	
-	if (copy_from_user(&ifc, arg, sizeof(struct ifconf)))
-		return -EFAULT;
+
+	if (flag == 0) {	
+		if (copy_from_user(&ifc, arg, sizeof(struct ifconf)))
+			return -EFAULT;
+	} else
+		memcpy(&ifc, arg, sizeof(struct ifconf));
 
 	pos = ifc.ifc_buf;
 	len = ifc.ifc_len;
@@ -1667,8 +1673,11 @@
 	 */
 	ifc.ifc_len = total;
 
-	if (copy_to_user(arg, &ifc, sizeof(struct ifconf)))
-		return -EFAULT; 
+	if (flag == 0) {
+		if (copy_to_user(arg, &ifc, sizeof(struct ifconf)))
+			return -EFAULT; 
+	} else 
+		memcpy(arg, &ifc, sizeof(struct ifconf));
 
 	/* 
 	 * 	Both BSD and Solaris return 0 here, so we do too.
@@ -1676,6 +1685,11 @@
 	return 0;
 }
 
+static int dev_ifconf(char *arg)
+{
+	return dev_ifconf2(arg, 0);
+}
+
 /*
  *	This is invoked by the /proc filesystem handler to display a device
  *	in detail.
@@ -1956,7 +1970,7 @@
  *	Perform the SIOCxIFxxx calls. 
  */
  
-static int dev_ifsioc(struct ifreq *ifr, unsigned int cmd)
+static int dev_ifsioc2(struct ifreq *ifr, unsigned int cmd, int flag)
 {
 	struct net_device *dev;
 	int err;
@@ -2123,6 +2137,11 @@
 	return -EINVAL;
 }
 
+static int dev_ifsioc(struct ifreq *ifr, unsigned int cmd)
+{
+	return dev_ifsioc2(ifr, cmd, 0);
+}
+
 /*
  *	This function handles all "interface"-type I/O control requests. The actual
  *	'doing' part of this is dev_ifsioc above.
@@ -2139,7 +2158,7 @@
  *	positive or a negative errno code on error.
  */
 
-int dev_ioctl(unsigned int cmd, void *arg)
+int dev_ioctl2(unsigned int cmd, void *arg, int flag)
 {
 	struct ifreq ifr;
 	int ret;
@@ -2152,7 +2171,10 @@
 	   
 	if (cmd == SIOCGIFCONF) {
 		rtnl_shlock();
-		ret = dev_ifconf((char *) arg);
+		if (flag == 1)
+			ret = dev_ifconf2((char *) arg, 1);
+		else
+			ret = dev_ifconf((char *) arg);
 		rtnl_shunlock();
 		return ret;
 	}
@@ -2160,8 +2182,11 @@
 		return dev_ifname((struct ifreq *)arg);
 	}
 
-	if (copy_from_user(&ifr, arg, sizeof(struct ifreq)))
-		return -EFAULT;
+	if (flag == 0) {
+		if (copy_from_user(&ifr, arg, sizeof(struct ifreq)))
+			return -EFAULT;
+	} else
+		memcpy(&ifr, arg, sizeof(struct ifreq));
 
 	ifr.ifr_name[IFNAMSIZ-1] = 0;
 
@@ -2192,13 +2217,19 @@
 		case SIOCGIFTXQLEN:
 			dev_load(ifr.ifr_name);
 			read_lock(&dev_base_lock);
-			ret = dev_ifsioc(&ifr, cmd);
+			if (flag == 1)
+				ret = dev_ifsioc2(&ifr, cmd, 1);
+			else
+				ret = dev_ifsioc(&ifr, cmd);
 			read_unlock(&dev_base_lock);
 			if (!ret) {
 				if (colon)
 					*colon = ':';
-				if (copy_to_user(arg, &ifr, sizeof(struct ifreq)))
+				if (flag == 0) {
+				  if (copy_to_user(arg, &ifr, sizeof(struct ifreq)))
 					return -EFAULT;
+				} else 
+				  memcpy(arg, &ifr, sizeof(struct ifreq));
 			}
 			return ret;
 
@@ -2217,14 +2248,20 @@
 			dev_load(ifr.ifr_name);
 			dev_probe_lock();
 			rtnl_lock();
-			ret = dev_ifsioc(&ifr, cmd);
+			if (flag == 1)
+				ret = dev_ifsioc2(&ifr, cmd, 1);
+			else
+				ret = dev_ifsioc(&ifr, cmd);
 			rtnl_unlock();
 			dev_probe_unlock();
 			if (!ret) {
 				if (colon)
 					*colon = ':';
-				if (copy_to_user(arg, &ifr, sizeof(struct ifreq)))
+				if (flag == 0) {
+				  if (copy_to_user(arg, &ifr, sizeof(struct ifreq)))
 					return -EFAULT;
+				} else 
+				  memcpy(arg, &ifr, sizeof(struct ifreq));
 			}
 			return ret;
 
@@ -2258,7 +2295,10 @@
 			dev_load(ifr.ifr_name);
 			dev_probe_lock();
 			rtnl_lock();
-			ret = dev_ifsioc(&ifr, cmd);
+			if (flag == 1)
+				ret = dev_ifsioc2(&ifr, cmd, 1);
+			else
+				ret = dev_ifsioc(&ifr, cmd);
 			rtnl_unlock();
 			dev_probe_unlock();
 			return ret;
@@ -2281,11 +2321,18 @@
 				dev_load(ifr.ifr_name);
 				dev_probe_lock();
 				rtnl_lock();
-				ret = dev_ifsioc(&ifr, cmd);
+				if (flag == 1)
+					ret = dev_ifsioc2(&ifr, cmd, 1);
+				else
+					ret = dev_ifsioc(&ifr, cmd);
 				rtnl_unlock();
 				dev_probe_unlock();
-				if (!ret && copy_to_user(arg, &ifr, sizeof(struct ifreq)))
+				if (flag == 0) {
+				  if (!ret && copy_to_user(arg, &ifr, sizeof(struct ifreq)))
 					return -EFAULT;
+				} else {
+				  memcpy(arg, &ifr, sizeof(struct ifreq));
+				}
 				return ret;
 			}
 #ifdef WIRELESS_EXT
@@ -2301,11 +2348,17 @@
 				dev_load(ifr.ifr_name);
 				rtnl_lock();
 				/* Follow me in net/core/wireless.c */
-				ret = wireless_process_ioctl(&ifr, cmd);
+				if (flag == 1)
+					ret = wireless_process_ioctl2(&ifr, cmd, 1);
+				else 
+					ret = wireless_process_ioctl(&ifr, cmd);
 				rtnl_unlock();
+				if (flag == 0) {
 				if (!ret && IW_IS_GET(cmd) &&
 				    copy_to_user(arg, &ifr, sizeof(struct ifreq)))
 					return -EFAULT;
+				} else
+					memcpy(arg, &ifr, sizeof(struct ifreq));
 				return ret;
 			}
 #endif	/* WIRELESS_EXT */
@@ -2313,6 +2366,10 @@
 	}
 }
 
+int dev_ioctl(unsigned int cmd, void *arg)
+{
+	return dev_ioctl2(cmd, arg, 0);
+}
 
 /**
  *	dev_new_index	-	allocate an ifindex
diff -Naur test-for-latech/net/core/filter.c testqf-for-latech/net/core/filter.c
--- test-for-latech/net/core/filter.c	2004-06-11 07:40:49.000000000 -0400
+++ testqf-for-latech/net/core/filter.c	2004-06-11 07:47:57.000000000 -0400
@@ -325,9 +325,21 @@
 				continue;
 
 			case BPF_RET|BPF_K:
+/*
+#ifdef CONFIG_QFABRIC
+				wake_up_interruptible((wait_queue_head_t *)
+						&global_wait_queue);
+#endif
+*/
 				return ((unsigned int)fentry->k);
 
 			case BPF_RET|BPF_A:
+/*
+#ifdef CONFIG_QFABRIC
+				wake_up_interruptible((wait_queue_head_t *)
+						&global_wait_queue);
+#endif
+*/
 				return ((unsigned int)A);
 
 			case BPF_ST:
diff -Naur test-for-latech/net/core/skbuff.c testqf-for-latech/net/core/skbuff.c
--- test-for-latech/net/core/skbuff.c	2004-06-11 07:40:49.000000000 -0400
+++ testqf-for-latech/net/core/skbuff.c	2004-06-11 07:47:57.000000000 -0400
@@ -204,6 +204,11 @@
 	skb->cloned = 0;
 	skb->data_len = 0;
 
+#ifdef CONFIG_QFABRIC
+	skb->deadline = -1;
+	skb->flags = 0;
+#endif
+
 	atomic_set(&skb->users, 1); 
 	atomic_set(&(skb_shinfo(skb)->dataref), 1);
 	skb_shinfo(skb)->nr_frags = 0;
diff -Naur test-for-latech/net/core/sock.c testqf-for-latech/net/core/sock.c
--- test-for-latech/net/core/sock.c	2004-06-11 07:40:49.000000000 -0400
+++ testqf-for-latech/net/core/sock.c	2004-06-11 07:47:57.000000000 -0400
@@ -119,6 +119,17 @@
 #include <linux/skbuff.h>
 #include <net/sock.h>
 #include <linux/ipsec.h>
+#include <linux/sched.h>
+#ifdef CONFIG_QFABRIC
+//#include <sys/syscall.h>   /* --CP-- */
+#include <asm/unistd.h>
+
+extern void *sys_call_table[];
+extern void call_wake_up(int, int, int, int, void*);
+
+extern int request_socket_deadline(struct sock *sk);
+extern int request_socket_rt_flags(struct sock *sk);
+#endif
 
 #ifdef CONFIG_FILTER
 #include <linux/filter.h>
@@ -435,6 +446,16 @@
 		
   	switch(optname) 
   	{
+#ifdef CONFIG_QFABRIC
+		case SO_QOS_PRIORITY:
+			v.val = sk->qos_priority;
+			break;
+
+		case SO_QOS_DEADLINE:
+			v.val = sk->qos_deadline;
+			break;
+#endif
+
 		case SO_DEBUG:		
 			v.val = sk->debug;
 			break;
@@ -672,6 +693,12 @@
 		struct sk_buff * skb = alloc_skb(size, priority);
 		if (skb) {
 			skb_set_owner_w(skb, sk);
+#ifdef CONFIG_QFABRIC
+			if (sk->socket != NULL) {
+				skb->deadline = request_socket_deadline(sk);
+				skb->flags = request_socket_rt_flags(sk);
+			}
+#endif
 			return skb;
 		}
 	}
@@ -1117,7 +1144,7 @@
 void sock_def_wakeup(struct sock *sk)
 {
 	read_lock(&sk->callback_lock);
-	if (sk->sleep && waitqueue_active(sk->sleep))
+	if (sk->sleep && waitqueue_active(sk->sleep)) 
 		wake_up_interruptible_all(sk->sleep);
 	read_unlock(&sk->callback_lock);
 }
@@ -1133,15 +1160,29 @@
 
 void sock_def_readable(struct sock *sk, int len)
 {
+#ifdef CONFIG_QFABRIC
+	struct task_struct *tsk;
+#endif
 	read_lock(&sk->callback_lock);
 	if (sk->sleep && waitqueue_active(sk->sleep))
 		wake_up_interruptible(sk->sleep);
+#ifdef CONFIG_QFABRIC
+	if (sk->readable > 0) {
+		if ((tsk = find_task_by_pid(sk->owner)) != NULL)
+			if ((tsk->state >= 0) && (tsk->state < 2)) 
+				call_wake_up(sk->fd,sk->owner,0,sk->kecho,
+					sk->kecho_ptr);
+	}
+#endif
 	sk_wake_async(sk,1,POLL_IN);
 	read_unlock(&sk->callback_lock);
 }
 
 void sock_def_write_space(struct sock *sk)
 {
+#ifdef CONFIG_QFABRIC
+	struct task_struct *tsk;
+#endif
 	read_lock(&sk->callback_lock);
 
 	/* Do not wake up a writer until he can make "significant"
@@ -1154,6 +1195,13 @@
 		/* Should agree with poll, otherwise some programs break */
 		if (sock_writeable(sk))
 			sk_wake_async(sk, 2, POLL_OUT);
+#ifdef CONFIG_QFABRIC
+		if (sk->writable > 0)
+			if ((tsk = find_task_by_pid(sk->owner)) != NULL)
+				if ((tsk->state >= 0) && (tsk->state < 2))
+					call_wake_up(sk->fd,sk->owner,1,sk->kecho,
+						sk->kecho_ptr);
+#endif
 	}
 
 	read_unlock(&sk->callback_lock);
diff -Naur test-for-latech/net/core/wireless.c testqf-for-latech/net/core/wireless.c
--- test-for-latech/net/core/wireless.c	2004-06-11 07:40:49.000000000 -0400
+++ testqf-for-latech/net/core/wireless.c	2004-06-11 07:47:57.000000000 -0400
@@ -673,7 +673,7 @@
  * (dev_ioctl() in net/core/dev.c).
  * Check the type of IOCTL and call the appropriate wrapper...
  */
-int wireless_process_ioctl(struct ifreq *ifr, unsigned int cmd)
+int wireless_process_ioctl2(struct ifreq *ifr, unsigned int cmd, int flag)
 {
 	struct net_device *dev;
 	iw_handler	handler;
@@ -731,3 +731,8 @@
 	/* Not reached */
 	return -EINVAL;
 }
+
+int wireless_process_ioctl(struct ifreq *ifr, unsigned int cmd)
+{
+  return wireless_process_ioctl2(ifr, cmd, 0);
+}
diff -Naur test-for-latech/net/ipv4/tcp.c testqf-for-latech/net/ipv4/tcp.c
--- test-for-latech/net/ipv4/tcp.c	2004-06-11 07:40:50.000000000 -0400
+++ testqf-for-latech/net/ipv4/tcp.c	2004-06-11 07:47:57.000000000 -0400
@@ -1511,6 +1511,10 @@
 		 * handling. FIXME: Need to check this doesnt impact 1003.1g
 		 * and move it down to the bottom of the loop
 		 */
+
+#ifdef CONFIG_QFABRIC
+		if (sk->kecho != 1) 	
+#endif
 		if (signal_pending(current)) {
 			if (copied)
 				break;
@@ -1590,6 +1594,9 @@
 		if (tp->ucopy.task == user_recv) {
 			/* Install new reader */
 			if (user_recv == NULL && !(flags&(MSG_TRUNC|MSG_PEEK))) {
+#ifdef CONFIG_QFABRIC
+				if (sk->kecho != 1) 	
+#endif
 				user_recv = current;
 				tp->ucopy.task = user_recv;
 				tp->ucopy.iov = msg->msg_iov;
diff -Naur test-for-latech/net/ipv4/tcp_ipv4.c testqf-for-latech/net/ipv4/tcp_ipv4.c
--- test-for-latech/net/ipv4/tcp_ipv4.c	2004-06-11 07:40:50.000000000 -0400
+++ testqf-for-latech/net/ipv4/tcp_ipv4.c	2004-06-11 07:47:57.000000000 -0400
@@ -1521,7 +1521,12 @@
 	tcp_openreq_free(req); 
 drop:
 	TCP_INC_STATS_BH(TcpAttemptFails);
+/* --CP-- */
+#ifdef CONFIG_QFABRIC
+	return -ENOTCONN; /* send reset */
+#else
 	return 0;
+#endif
 }
 
 
diff -Naur test-for-latech/net/Makefile testqf-for-latech/net/Makefile
--- test-for-latech/net/Makefile	2004-06-11 07:40:47.000000000 -0400
+++ testqf-for-latech/net/Makefile	2004-06-11 07:47:57.000000000 -0400
@@ -7,7 +7,8 @@
 
 O_TARGET :=	network.o
 
-mod-subdirs :=	ipv4/netfilter ipv6/netfilter ipx irda bluetooth atm netlink sched core
+mod-subdirs :=	ipv4/netfilter ipv6/netfilter ipx irda bluetooth atm netlink sched core \
+		qsocket
 export-objs :=	netsyms.o
 
 subdir-y :=	core ethernet
@@ -15,6 +16,7 @@
 
 
 subdir-$(CONFIG_NET)		+= 802 sched netlink
+subdir-$(CONFIG_NET_QSOCKET)	+= qsocket
 subdir-$(CONFIG_INET)		+= ipv4
 subdir-$(CONFIG_NETFILTER)	+= ipv4/netfilter
 subdir-$(CONFIG_UNIX)		+= unix
diff -Naur test-for-latech/net/netsyms.c testqf-for-latech/net/netsyms.c
--- test-for-latech/net/netsyms.c	2004-06-11 07:40:47.000000000 -0400
+++ testqf-for-latech/net/netsyms.c	2004-06-11 07:47:57.000000000 -0400
@@ -28,6 +28,7 @@
 #include <linux/hippidevice.h>
 #endif
 #include <net/pkt_sched.h>
+#include <net/pkt_cls.h>
 #include <net/scm.h>
 #include <linux/if_bridge.h>
 #include <linux/if_vlan.h>
@@ -35,6 +36,9 @@
 #ifdef CONFIG_NET_DIVERT
 #include <linux/divert.h>
 #endif /* CONFIG_NET_DIVERT */
+#ifdef CONFIG_NET_QSOCKET
+#include <linux/qsocket.h>
+#endif
 
 #ifdef CONFIG_NET
 extern __u32 sysctl_wmem_max;
@@ -106,11 +110,17 @@
 EXPORT_SYMBOL(memcpy_fromiovec);
 EXPORT_SYMBOL(memcpy_tokerneliovec);
 EXPORT_SYMBOL(sock_create);
+#ifdef CONFIG_QFABRIC
+EXPORT_SYMBOL(make_rt_sock);
+#endif
 EXPORT_SYMBOL(sock_alloc);
 EXPORT_SYMBOL(sock_release);
 EXPORT_SYMBOL(sock_setsockopt);
 EXPORT_SYMBOL(sock_getsockopt);
 EXPORT_SYMBOL(sock_sendmsg);
+#ifdef CONFIG_QFABRIC
+EXPORT_SYMBOL(rt_sock_sendmsg);
+#endif
 EXPORT_SYMBOL(sock_recvmsg);
 EXPORT_SYMBOL(sk_alloc);
 EXPORT_SYMBOL(sk_free);
@@ -500,6 +510,9 @@
 EXPORT_SYMBOL(dev_load);
 #endif
 EXPORT_SYMBOL(dev_ioctl);
+#ifdef CONFIG_QFABRIC
+EXPORT_SYMBOL(dev_ioctl2);
+#endif
 EXPORT_SYMBOL(dev_queue_xmit);
 #ifdef CONFIG_NET_HW_FLOWCONTROL
 EXPORT_SYMBOL(netdev_dropping);
@@ -548,6 +561,9 @@
 EXPORT_SYMBOL(qdisc_get_rtab);
 EXPORT_SYMBOL(qdisc_put_rtab);
 EXPORT_SYMBOL(qdisc_copy_stats);
+EXPORT_SYMBOL(qdisc_lookup_ops_string);
+EXPORT_SYMBOL(qdisc_alloc_handle);
+EXPORT_SYMBOL(qdisc_graft);
 #ifdef CONFIG_NET_ESTIMATOR
 EXPORT_SYMBOL(qdisc_new_estimator);
 EXPORT_SYMBOL(qdisc_kill_estimator);
@@ -562,6 +578,9 @@
 #ifdef CONFIG_NET_CLS
 EXPORT_SYMBOL(register_tcf_proto_ops);
 EXPORT_SYMBOL(unregister_tcf_proto_ops);
+#ifdef CONFIG_NET_CLS_SOCKET
+EXPORT_SYMBOL(cls_socket_ops);
+#endif
 #endif
 #ifdef CONFIG_NETFILTER
 #include <linux/netfilter.h>
@@ -588,4 +607,13 @@
 EXPORT_SYMBOL(net_call_rx_atomic);
 EXPORT_SYMBOL(softnet_data);
 
+#ifdef CONFIG_NET_QSOCKET
+EXPORT_SYMBOL(qop_base);
+#endif
+
+#ifdef CONFIG_QFABRIC
+EXPORT_SYMBOL(tcp_mem_schedule);
+EXPORT_SYMBOL(tcp_memory_pressure);
+#endif
+
 #endif  /* CONFIG_NET */
diff -Naur test-for-latech/net/qsocket/dwcs.h testqf-for-latech/net/qsocket/dwcs.h
--- test-for-latech/net/qsocket/dwcs.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/net/qsocket/dwcs.h	2004-06-11 07:48:02.000000000 -0400
@@ -0,0 +1,110 @@
+
+void watchdog(unsigned long arg)
+{
+	struct net_device *dev = (struct net_device*) arg;
+	if(dev)
+	{
+		netif_schedule(dev);
+	}
+}
+
+
+
+void dwcs_init_timer(struct timer_list *wd_timer, struct net_device *dev)
+{
+	init_timer(wd_timer);
+	wd_timer->function = watchdog;
+	wd_timer->data = (unsigned long)dev;  
+}
+
+
+/*
+** dwcs_link_class() inserts the class in qdisc's linked list.
+** It should be executed atomically.
+*/
+static void dwcs_link_class(struct dwcs_class *this)
+{
+	struct dwcs_sched_data *q = (struct dwcs_sched_data*)this->qdisc->data;
+	unsigned h                = dwcs_hash(this->classid);
+
+	this->next    = q->classes[h];
+	q->classes[h] = this;
+
+}
+
+/*
+ * Helper function to return the address of the class
+ * by providing the classid (that includes major and minor ids),
+ * Returns NULL, if no class is found.
+ */
+static __inline__ struct dwcs_class *
+dwcs_class_lookup ( struct dwcs_sched_data *q,
+					u32 classid )
+{
+	struct dwcs_class  *cl;
+
+	for ( cl = q->classes[dwcs_hash ( classid )]; cl; cl = cl->next )
+		if ( cl->classid == classid )
+		{
+			return cl;
+		}
+
+	return NULL;
+}
+
+
+
+static int q_dwcs_init(struct Qdisc *sch)
+{
+	struct dwcs_sched_data *q = (void*)sch->data;
+	
+	q->dlheap_size = 0;
+	q->ltheap_size = 0;
+	q->slheap_size = 0;
+	
+	q->link = (struct dwcs_class*) kmalloc(sizeof(struct dwcs_class), GFP_KERNEL);
+	if(q->link == NULL)
+	{
+		return -ENOBUFS;
+	}	
+	memset(q->link, 0, sizeof(struct dwcs_class));
+	
+	q->link->filter_list = NULL;
+	q->link->refcnt = 1;
+	q->link->classid = sch->handle;
+	q->link->qdisc = sch;
+
+	if(!(q->link->q = qdisc_create_dflt(sch->dev, &pfifo_qdisc_ops)))
+	{
+		printk("no op qdisc \n");
+		q->link->q = &noop_qdisc;
+	}
+
+	if(sch->dev == NULL)
+		printk("dev == NULL : qsocket\n");
+	else 
+		dwcs_init_timer(&q->wd_timer, sch->dev);
+
+	
+	q->link->attr.ipg = 1;
+	q->link->attr.oln = 0;
+	q->link->attr.old = 1;
+	q->link->attr.flags = 0;
+	q->link->attr.cln  = 0;             /* Current loss numerator. */
+	q->link->attr.cld  = 0;             /* Current loss denominator. */
+	q->link->attr.droppable = FALSE;    /* TRUE if packets can be dropped */
+	q->link->attr.cln  = q->link->attr.oln;
+	q->link->attr.cld  = q->link->attr.old;
+	q->link->attr.clt  = (100 * q->link->attr.oln / q->link->attr.old);
+	q->link->attr.deadline = -1;
+	q->link->attr.readytime = -1;
+	
+	memset(q->classes, 0, sizeof(struct dwcs_class*) * 16);
+	
+	dwcs_link_class(q->link);
+	q->classcount = 1;
+
+	return 0;
+	
+}
+
diff -Naur test-for-latech/net/qsocket/Makefile testqf-for-latech/net/qsocket/Makefile
--- test-for-latech/net/qsocket/Makefile	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/net/qsocket/Makefile	2004-06-11 07:48:02.000000000 -0400
@@ -0,0 +1,7 @@
+#Makefile for qsocket 
+
+O_TARGET := qsocket.o
+
+obj-$(CONFIG_NET_QSOCKET) += qsock.o
+
+include $(TOPDIR)/Rules.make
